TidyPlatesThreat = LibStub("AceAddon-3.0"):NewAddon("TidyPlatesThreat", "AceConsole-3.0","AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")
local DataBroker = LibStub:GetLibrary("LibDataBroker-1.1",true)
local path = "\\Interface\\Addons\\TidyPlates_ThreatPlates\\"

--[[Set MultiStyle]]--
if not TidyPlatesThemeList then TidyPlatesThemeList = {} end
TidyPlatesThemeList["ThreatPlates"] = {}

--[[Options and Default Settings]]--
function TidyPlatesThreat:OnInitialize()
	local options = { 
        type = 'group', args = {
				OnOff = {
				        order = 1,
				        type  = 'toggle',
            			name  = "Enable Threat Plates",
				        desc  = "Turn on the threat system plates.",
            			get   = function() return self.db.profile.threat end,
				        set   = function(info,val) 
							self.db.profile.threat = not self.db.profile.threat;
							if self.db.profile.threat then return print("-->>|cff00ffffThreat Plates Toggled|r |cff00ff00ON!|r<<--") else return print("-->>|cff00ffffThreat Plates Toggled|r |cffff0000OFF!|r<<--") end
							end
					},
				Tank = {
				        order = 4,
				        type  = 'toggle',
            			name  = "Enable DPS Role",
				        desc  = "Toggle DPS Role styled Threat Plates.",
            			get   = function() return not self.db.profile.role end,
				        set   = function(info,val) 
							self.db.profile.role = false;
							self.db.profile.threat = true;
							print("-->>|cffff0000DPS Plates Enabled|r<<--")
							end
					},
				DPS = {
				        order = 5,
				        type  = 'toggle',
            			name  = "Enable Tank Role",
				        desc  = "Toggle Tanking Role styled Threat Plates.",
            			get   = function() return self.db.profile.role end,
				        set   = function(info,val) 
							self.db.profile.role = true;
							self.db.profile.threat = true;
							print("-->>|cff00ff00Tank Plates Enabled|r<<--")
							end
					},
				TextHeader1 = {
						type = "header",
						order = 2,
						name = "Welcome to TidyPlates: ThreatPlates v1.5",
					},
				TextHeader2 = {
						type = "header",
						order = 3,
						name = "Created by: Syronius of Black Dragonflight, US",
					},
				TextHeader3 = {
						type = "header",
						order = 6,
						name = "Commands List:"
					},			
				TextInfo = {
						type = "description",
						order = 7,
						name = "/tptp - Options Menu".."\n".."/tptptoggle - Toggle between DPS and Tanking".."\n".."/tptpdps - Toggle DPS Plates ( Usable in macros )".."\n".."/tptptank - Toggle Tank Plates ( Usable in macros )",
					},
				--[[texture = {
						type = 'select',
						name = 'Texture',
						desc = 'Set the bar Texture',
						values = function() 
							local list = {}
							for k, v in pairs(Media:List('statusbar')) do
								list[v] = v
							end 
							return list
						end,
						get = function() return self.db.profile.texture  end,
						set = function(info,val) 
							self.db.profile.texture = val
							end,
						order = 4,
					},]]--
			},
	}
	local defaults 	= {
		profile = {
			role 			= true,
			threat 			= true
		}
    }
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Tidy Plates: Threat Plates Options:", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Tidy Plates: Threat Plates Options:", "Tidy Plates: Threat Plates")
	self:RegisterChatCommand("tptp", function () InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end)
	self.message = ""
	self.db = LibStub("AceDB-3.0"):New("ThreatPlatesDB", defaults)
	local db = self.db.profile
	--[[
	Media.RegisterCallback(self, "LibSharedMedia_Registered", "UpdateMedia")
	Media.RegisterCallback(self, "LibSharedMedia_SetGlobal", "UpdateMedia")
	]]--
end

--[[Unutilized UpdateMedia]]--

--[[function TidyPlatesThreat:UpdateMedia(callback, type, handle)
	if type == "statusbar" then
		self.heal_bars:SetTexture(Media:Fetch("statusbar", self.db.profile.texture))
		self.cast_bars:SetTexture(Media:Fetch("statusbar", self.db.profile.texture2))
	end
end
]]--

--[[TPTP Tank Toggle Command]]--

local function TPTPTANK()
	TidyPlatesThreat.db.profile.role = true
	print("-->>|cff00ff00Tank Plates Enabled|r<<--")
end
SLASH_TPTPTANK1 = "/tptptank"
SlashCmdList["TPTPTANK"] = TPTPTANK

--[[TPTP DPS Toggle Command]]--

local function TPTPDPS()
	print("-->>|cffff0000DPS Plates Enabled|r<<--")
	TidyPlatesThreat.db.profile.role = false
end
SLASH_TPTPDPS1 = "/tptpdps"
SlashCmdList["TPTPDPS"] = TPTPDPS
--[[TPTP Role Toggle Command]]--
local function TPTPTOGGLE()
	TidyPlatesThreat.db.profile.role = not TidyPlatesThreat.db.profile.role
	if TidyPlatesThreat.db.profile.role then 
		return print("-->>|cff00ff00Tank Plates Enabled|r<<--")
	else
		return print("-->>|cffff0000DPS Plates Enabled|r<<--")
	end
end
SLASH_TPTPTOGGLE1 = "/tptptoggle"
SlashCmdList["TPTPTOGGLE"] = TPTPTOGGLE

--[[Set Style with conditionals]]--

local function SetStyle(unit)
	if unit.threatSituation == "LOW" and InCombatLockdown() and unit.reaction == "HOSTILE" and TidyPlatesThreat.db.profile.role and TidyPlatesThreat.db.profile.threat
		then return "low"
	elseif unit.threatSituation == "LOW" and InCombatLockdown() and unit.reaction == "HOSTILE" and not TidyPlatesThreat.db.profile.role and TidyPlatesThreat.db.profile.threat
		then return "high"
	elseif unit.threatSituation == "HIGH" and InCombatLockdown() and unit.reaction == "HOSTILE" and TidyPlatesThreat.db.profile.role and TidyPlatesThreat.db.profile.threat
		then return "high"
	elseif unit.threatSituation == "HIGH" and InCombatLockdown() and unit.reaction == "HOSTILE" and not TidyPlatesThreat.db.profile.role and TidyPlatesThreat.db.profile.threat
		then return "low"
	elseif unit.threatSituation == "MEDIUM" and InCombatLockdown() and unit.reaction == "HOSTILE" and TidyPlatesThreat.db.profile.threat
		then return "medium"
	else
		return "normal" 
	end
end

local Truncate = function(value)
	if value >= 1e6 then
		return format('%.1fm', value / 1e6)
	elseif value >= 1e4 then
		return format('%.1fk', value / 1e3)
	else
		return value
	end
end

--[[Name the Style]]--
function SetSpecialText(unit)
	healthpercent = 100* (unit.health / unit.healthmax) 				--[[Creates the health percentage number]]--
	if (unit.health / unit.healthmax) < 1 then 							--[[If Health is less than 100%]]--
		return Truncate(unit.health).." - "..ceil(healthpercent ).."%" 	--[[Display Truncated HP Amount and Percentage]]--
	else 																--[[If HP is 100%]]--
		return --[[ceil(healthpercent ).."%"]]--								--[[Display Nothing or Optional 100% text]]--
	end
end

local classByColor = {
C285 = "Deathknight",
C390 = "Druid",
C498 = "Hunter",
C549 = "Mage",
C571 = "Paladin",
C768 = "Priest",	
C605 = "Rogue",	
C335 = "Shaman",	
C479 = "Warlock",
C465 = "Warrior",
--C256 = "Npc",
}
--[[Set Texture]]--

function SetSpecialArt(unit)
	if unit.reaction == "HOSTILE" then
		local r = ceil(unit.red*256)
		local g = ceil(unit.green*256)
		local b = ceil(unit.blue*256)
		local class = nil
		local index = 0
		for index = -2, 3 do
			class = classByColor["C"..(r+g+b+index)]
			if class then return path.."Artwork\\Class\\ClassIcon_"..class end
		end
	end
	return nil
end

TidyPlatesThemeList["ThreatPlates"].SetStyle = SetStyle
TidyPlatesThemeList["ThreatPlates"].SetSpecialText = SetSpecialText
TidyPlatesThemeList["ThreatPlates"].SetSpecialArt = SetSpecialArt

--[[Auto Settings]]--

SetCVar("threatWarning", 3)
SetCVar("nameplateShowEnemies", 1)
SetCVar("ShowClassColorInNameplate", 1)